## Canceling if at max Ammo
execute store result score GunMaxAmmo gbg.temp run data get entity @s SelectedItem.tag.GunMaxAmmo
execute store result score GunAmmo gbg.temp run data get entity @s SelectedItem.tag.GunAmmo
execute if score GunAmmo gbg.temp = GunMaxAmmo gbg.temp run return 0


## Removing Ammo from Inventory and Setting Cooldown
execute store result score GunAmmoType gbg.temp run data get entity @s SelectedItem.tag.GunAmmoType
execute store result score GunReloadSpeed gbg.temp run data get entity @s SelectedItem.tag.GunReloadSpeed
scoreboard players operation @s gbg.cooldown = GunReloadSpeed gbg.temp
#pistol
execute if score GunAmmoType gbg.temp matches 1 if entity @s[nbt=!{Inventory:[{tag:{pistol_ammo:1b}}]}] run function gbg:reload/out_of_ammo
execute if score GunAmmoType gbg.temp matches 1 if entity @s[nbt=!{Inventory:[{tag:{pistol_ammo:1b}}]}] run return 0
execute if score GunAmmoType gbg.temp matches 1 run clear @s command_block{pistol_ammo:1b} 1
#assault rifle
execute if score GunAmmoType gbg.temp matches 2 if entity @s[nbt=!{Inventory:[{tag:{assault_ammo:1b}}]}] run function gbg:reload/out_of_ammo
execute if score GunAmmoType gbg.temp matches 2 if entity @s[nbt=!{Inventory:[{tag:{assault_ammo:1b}}]}] run return 0
execute if score GunAmmoType gbg.temp matches 2 run clear @s command_block{assault_ammo:1b} 1
#sniper rifle
execute if score GunAmmoType gbg.temp matches 3 if entity @s[nbt=!{Inventory:[{tag:{sniper_ammo:1b}}]}] run function gbg:reload/out_of_ammo
execute if score GunAmmoType gbg.temp matches 3 if entity @s[nbt=!{Inventory:[{tag:{sniper_ammo:1b}}]}] run return 0
execute if score GunAmmoType gbg.temp matches 3 run clear @s command_block{sniper_ammo:1b} 1
#shotgun
execute if score GunAmmoType gbg.temp matches 4 if entity @s[nbt=!{Inventory:[{tag:{shotgun_ammo:1b}}]}] run function gbg:reload/out_of_ammo
execute if score GunAmmoType gbg.temp matches 4 if entity @s[nbt=!{Inventory:[{tag:{shotgun_ammo:1b}}]}] run return 0
execute if score GunAmmoType gbg.temp matches 4 run clear @s command_block{shotgun_ammo:1b} 1
#bazooka
execute if score GunAmmoType gbg.temp matches 5 if entity @s[nbt=!{Inventory:[{tag:{rocket:1b}}]}] run function gbg:reload/out_of_ammo
execute if score GunAmmoType gbg.temp matches 5 if entity @s[nbt=!{Inventory:[{tag:{rocket:1b}}]}] run return 0
execute if score GunAmmoType gbg.temp matches 5 run clear @s command_block{rocket:1b} 1
#flame thrower
execute if score GunAmmoType gbg.temp matches 6 if entity @s[nbt=!{Inventory:[{tag:{flame_thrower_ammo:1b}}]}] run function gbg:reload/out_of_ammo
execute if score GunAmmoType gbg.temp matches 6 if entity @s[nbt=!{Inventory:[{tag:{flame_thrower_ammo:1b}}]}] run return 0
execute if score GunAmmoType gbg.temp matches 6 run clear @s command_block{flame_thrower_ammo:1b} 1
#laser pistol
execute if score GunAmmoType gbg.temp matches 7 if entity @s[nbt=!{Inventory:[{tag:{9v:1b}}]}] run function gbg:reload/out_of_ammo
execute if score GunAmmoType gbg.temp matches 7 if entity @s[nbt=!{Inventory:[{tag:{9v:1b}}]}] run return 0
execute if score GunAmmoType gbg.temp matches 7 run clear @s command_block{9v:1b} 1
#laser rifle and assault laser rifle
execute if score GunAmmoType gbg.temp matches 8 if entity @s[nbt=!{Inventory:[{tag:{15v:1b}}]}] run function gbg:reload/out_of_ammo
execute if score GunAmmoType gbg.temp matches 8 if entity @s[nbt=!{Inventory:[{tag:{15v:1b}}]}] run return 0
execute if score GunAmmoType gbg.temp matches 8 run clear @s chain_command_block{15v:1b} 1
#laser cannon
execute if score GunAmmoType gbg.temp matches 9 if entity @s[nbt=!{Inventory:[{tag:{15vb:1b}}]}] run function gbg:reload/out_of_ammo
execute if score GunAmmoType gbg.temp matches 9 if entity @s[nbt=!{Inventory:[{tag:{15vb:1b}}]}] run return 0
execute if score GunAmmoType gbg.temp matches 9 run clear @s jigsaw{15vb:1b} 1


## Playing Sound
execute store result score GunSound gbg.temp run data get entity @s SelectedItem.tag.GunSound
execute if score GunSound gbg.temp matches ..0 run playsound minecraft:gbg_duck_quack player @a ~ ~ ~ 1 0.5
execute if score GunSound gbg.temp matches 1 run playsound minecraft:pistol_reload player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 2 run playsound minecraft:assault_rifle_reload player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 3 run playsound minecraft:sniper_rifle_reload player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 4 run playsound minecraft:shotgun_reload player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 5 run playsound minecraft:laser_cannon_reload player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 6 run playsound minecraft:flame_thrower_reload player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 7 run playsound minecraft:laser_pistol_reload player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 8 run playsound minecraft:laser_pistol_reload player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 9 run playsound minecraft:laser_cannon_reload player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 10 run playsound minecraft:gbg_duck_quack player @a ~ ~ ~ 1 0.5

## Updating Description and Tags
# getting gun stats
execute store result score GunDamage gbg.temp run data get entity @s SelectedItem.tag.GunDamage
execute store result score GunRange gbg.temp run data get entity @s SelectedItem.tag.GunRange
execute store result score GunFireRate gbg.temp run data get entity @s SelectedItem.tag.GunFireRate
# updating ammo
execute store result score GunReloadType gbg.temp run data get entity @s SelectedItem.tag.GunReloadType
execute if score GunReloadType gbg.temp matches 1 run scoreboard players operation GunAmmo gbg.temp = GunMaxAmmo gbg.temp
execute if score GunReloadType gbg.temp matches 2 run scoreboard players add GunAmmo gbg.temp 1
# updating durability visual
execute if score GunReloadType gbg.temp matches 1 run scoreboard players set new_damage gbg.temp 0
execute if score GunReloadType gbg.temp matches 2 run function gbg:calculate_durability
# applying new damage and ammo tags
data modify storage gbg:generic tag set value {}
execute store result storage gbg:generic tag.Damage int 1 run scoreboard players get new_damage gbg.temp
execute store result storage gbg:generic tag.GunAmmo int 1 run scoreboard players get GunAmmo gbg.temp
item modify entity @s weapon.mainhand gbg:general/change_damage
item modify entity @s weapon.mainhand gbg:general/change_ammo
# calculating gun damage for explosive weapons
execute store result score GunProType gbg.temp run data get entity @s SelectedItem.tag.GunProType
execute if score GunProType gbg.temp matches 2 run function gbg:calculate_damage
execute if score GunProType gbg.temp matches 6 run function gbg:calculate_damage
execute if score GunProType gbg.temp matches 9 run function gbg:calculate_damage
# building lore
item modify entity @s weapon.mainhand gbg:general/remove
item modify entity @s weapon.mainhand gbg:general/ammo
item modify entity @s weapon.mainhand gbg:general/gun_damage
item modify entity @s weapon.mainhand gbg:general/gun_range
item modify entity @s weapon.mainhand gbg:general/fire_rate



